searchNodes=[{"doc":"Utility module to import croma macros. Usage: Add the following line at the top of source file: use Croma","ref":"Croma.html","title":"Croma","type":"module"},{"doc":"Module that represents any Elixir term.","ref":"Croma.Any.html","title":"Croma.Any","type":"module"},{"doc":"Always returns true Intended to be used with other parts of croma to express variables with any type.","ref":"Croma.Any.html#valid?/1","title":"Croma.Any.valid?/1","type":"function"},{"doc":"","ref":"Croma.Any.html#t:t/0","title":"Croma.Any.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in atom type. Intended to be used with other parts of croma to express atom variables.","ref":"Croma.Atom.html","title":"Croma.Atom","type":"module"},{"doc":"Simply checks the argument's type using is_atom(var!(x)) .","ref":"Croma.Atom.html#valid?/1","title":"Croma.Atom.valid?/1","type":"function"},{"doc":"","ref":"Croma.Atom.html#t:t/0","title":"Croma.Atom.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in binary type. Intended to be used with other parts of croma to express binary variables.","ref":"Croma.Binary.html","title":"Croma.Binary","type":"module"},{"doc":"Simply checks the argument's type using is_binary(var!(x)) .","ref":"Croma.Binary.html#valid?/1","title":"Croma.Binary.valid?/1","type":"function"},{"doc":"","ref":"Croma.Binary.html#t:t/0","title":"Croma.Binary.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in bitstring type. Intended to be used with other parts of croma to express bitstring variables.","ref":"Croma.BitString.html","title":"Croma.BitString","type":"module"},{"doc":"Simply checks the argument's type using is_bitstring(var!(x)) .","ref":"Croma.BitString.html#valid?/1","title":"Croma.BitString.valid?/1","type":"function"},{"doc":"","ref":"Croma.BitString.html#t:t/0","title":"Croma.BitString.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in boolean type. Intended to be used with other parts of croma to express boolean variables.","ref":"Croma.Boolean.html","title":"Croma.Boolean","type":"module"},{"doc":"Simply checks the argument's type using is_boolean(var!(x)) .","ref":"Croma.Boolean.html#valid?/1","title":"Croma.Boolean.valid?/1","type":"function"},{"doc":"","ref":"Croma.Boolean.html#t:t/0","title":"Croma.Boolean.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in byte type. Intended to be used with other parts of croma to express byte variables.","ref":"Croma.Byte.html","title":"Croma.Byte","type":"module"},{"doc":"Simply checks the argument's type using var!(x) in 0..255 .","ref":"Croma.Byte.html#valid?/1","title":"Croma.Byte.valid?/1","type":"function"},{"doc":"","ref":"Croma.Byte.html#t:t/0","title":"Croma.Byte.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in char type. Intended to be used with other parts of croma to express char variables.","ref":"Croma.Char.html","title":"Croma.Char","type":"module"},{"doc":"Simply checks the argument's type using var!(x) in 0..1_114_111 .","ref":"Croma.Char.html#valid?/1","title":"Croma.Char.valid?/1","type":"function"},{"doc":"","ref":"Croma.Char.html#t:t/0","title":"Croma.Char.t/0","type":"type"},{"doc":"","ref":"Croma.DebugAssert.html","title":"Croma.DebugAssert","type":"module"},{"doc":"Ensures that the given expression evaluates to some truthy value at runtime and raises otherwise. This is intended to be used as debugging purposes: crash immediately when any logic error is found, similar to assert() in C. However note that, unlike C, crash of the currently running process does not necessarily stop execution of the program. Runtime checks by debug_assert/2 can be disabled by setting application config during compilation. config :croma , [ debug_assert : false ] The passed expression should be side effect free in order to preserve code semantics when disabled.","ref":"Croma.DebugAssert.html#debug_assert/2","title":"Croma.DebugAssert.debug_assert/2","type":"macro"},{"doc":"Module that provides Croma.Defpt.defpt/2 macro.","ref":"Croma.Defpt.html","title":"Croma.Defpt","type":"module"},{"doc":"Defines a unit-testable private function. When Mix.env() == :test , defpt defines a public function and thus it can be freely called from tests. Otherwise functions defined by defpt become private. Usage of this macro is exactly the same as the standard def and defp macros. Example use Croma defmodule M do defpt f ( x ) do IO . inspect ( x ) end end","ref":"Croma.Defpt.html#defpt/2","title":"Croma.Defpt.defpt/2","type":"macro"},{"doc":"Module that provides Croma.Defun.defun/2 macro.","ref":"Croma.Defun.html","title":"Croma.Defun","type":"module"},{"doc":"Defines a function together with its typespec. This provides a lighter-weight syntax for functions with type specifications and functions with multiple clauses. Example The following examples assume that Croma.Defun is imported (you can import it by use Croma ). defun f ( a :: integer , b :: String . t ) :: String . t do &quot; \#{ a } \#{ b } &quot; end The code above is expanded to the following function definition. @spec f ( integer , String . t ) :: String . t def f ( a , b ) do &quot; \#{ a } \#{ b } &quot; end Function with multiple clauses and/or pattern matching on parameters can be defined in the same way as case do ... end : defun dumbmap ( as :: [ a ] , f :: ( a -&gt; b ) ) :: [ b ] when a : term , b : term do ( [ ] , _ ) -&gt; [ ] ( [ h | t ] , f ) -&gt; [ f . ( h ) | dumbmap ( t , f ) ] end is converted to @spec dumbmap ( [ a ] , ( a -&gt; b ) ) :: [ b ] when a : term , b : term def dumbmap ( as , f ) def dumbmap ( [ ] , _ ) do [ ] end def dumbmap ( [ h | t ] , f ) do [ f . ( h ) | dumbmap ( t , f ) ] end Pattern matching on function parameter and omitting parameter's type If you omit parameter's type, its type is infered from the parameter's expression. Suppose we have the following function: defun f ( % MyStruct { field1 : field1 , field2 : field2 } ) :: String . t do &quot; \#{ field1 } \#{ field2 } &quot; end then the parameter type becomes MyStruct.t . @spec f ( MyStruct . t ) :: String . t def f ( a1 ) def f ( % MyStruct { field1 : field1 , field2 : field2 } ) do &quot; \#{ field1 } \#{ field2 } &quot; end Generating guards from argument types Simple guard expressions can be generated by defun/2 using g[type] syntax. For example, defun f ( s :: g [ String . t ] , i :: g [ integer ] ) :: String . t do &quot; \#{ s } \#{ i } &quot; end is converted to the following function with when is_integer(i) guard. @spec f ( String . t , integer ) :: String . t def f ( s , i ) def f ( s , i ) when is_binary ( s ) and is_integer ( i ) do &quot; \#{ s } \#{ i } &quot; end For supported types of guard-generation please refer to the source code of Croma.Guard.make/3 . Guard generation can be disabled by setting application config at compile time. For example, by putting the following into config/config.exs , config :croma , [ defun_generate_guard : false ] then g[String.t] becomes semantically the same as String.t . Validating arguments and return value based on their types You can instrument check of pre/post conditions by specifying type as v[type] . For instance, defmodule MyString do use Croma.SubtypeOfString , pattern : ~r/^foo|bar$/ end defun f ( s :: v [ MyString . t ] ) :: atom do String . to_atom ( s ) end becomes the following function definition that calls valid?/1 at the top of its body: @spec f ( MyString . t ) :: atom def f ( s ) def f ( s ) do if ! MyString . valid? ( s ) do raise &quot;...&quot; end String . to_atom ( s ) end The generated code assumes that valid?/1 function is defined in the type module of the specified type. For primitive types croma defines their type modules and thus you can freely use e.g. v[integer] . Generating validation of arguments and return values can be disabled by setting application config during compilation. config :croma , [ defun_generate_validation : false ] Known limitations Overloaded typespecs are not supported. Guard generation and validation are not allowed to be used with multi-clause syntax. Using unquote fragment in parameter list is not fully supported. try block is not implicitly started in body of defun , in contrast to def .","ref":"Croma.Defun.html#defun/2","title":"Croma.Defun.defun/2","type":"macro"},{"doc":"Defines a private function together with its typespec. See defun/2 for usage of this macro.","ref":"Croma.Defun.html#defunp/2","title":"Croma.Defun.defunp/2","type":"macro"},{"doc":"Defines a unit-testable private function together with its typespec. See defun/2 for usage of this macro. See also Croma.Defpt.defpt/2 .","ref":"Croma.Defun.html#defunpt/2","title":"Croma.Defun.defunpt/2","type":"macro"},{"doc":"Module that represents the Elixir's built-in float type. Intended to be used with other parts of croma to express float variables.","ref":"Croma.Float.html","title":"Croma.Float","type":"module"},{"doc":"Simply checks the argument's type using is_float(var!(x)) .","ref":"Croma.Float.html#valid?/1","title":"Croma.Float.valid?/1","type":"function"},{"doc":"","ref":"Croma.Float.html#t:t/0","title":"Croma.Float.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in function type. Intended to be used with other parts of croma to express function variables.","ref":"Croma.Function.html","title":"Croma.Function","type":"module"},{"doc":"Simply checks the argument's type using is_function(var!(x)) .","ref":"Croma.Function.html#valid?/1","title":"Croma.Function.valid?/1","type":"function"},{"doc":"","ref":"Croma.Function.html#t:t/0","title":"Croma.Function.t/0","type":"type"},{"doc":"Module to work with guard generation (see Croma.Defun.defun/2 ). This module is intended for internal use.","ref":"Croma.Guard.html","title":"Croma.Guard","type":"module"},{"doc":"","ref":"Croma.Guard.html#make/3","title":"Croma.Guard.make/3","type":"function"},{"doc":"Module that represents the Elixir's built-in integer type. Intended to be used with other parts of croma to express integer variables.","ref":"Croma.Integer.html","title":"Croma.Integer","type":"module"},{"doc":"Simply checks the argument's type using is_integer(var!(x)) .","ref":"Croma.Integer.html#valid?/1","title":"Croma.Integer.valid?/1","type":"function"},{"doc":"","ref":"Croma.Integer.html#t:t/0","title":"Croma.Integer.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in list type. Intended to be used with other parts of croma to express list variables.","ref":"Croma.List.html","title":"Croma.List","type":"module"},{"doc":"Simply checks the argument's type using is_list(var!(x)) .","ref":"Croma.List.html#valid?/1","title":"Croma.List.valid?/1","type":"function"},{"doc":"","ref":"Croma.List.html#t:t/0","title":"Croma.List.t/0","type":"type"},{"doc":"Implementation of Croma.Monad interface for built-in lists. This empowers the following Haskell-ish syntax for loops using lists: iex&gt; use Croma ...&gt; Croma.ListMonad . m do ...&gt; i &lt;- [ 1 , 2 , 3 ] ...&gt; j &lt;- [ 10 , 20 ] ...&gt; pure i + j ...&gt; end [ 11 , 21 , 12 , 22 , 13 , 23 ]","ref":"Croma.ListMonad.html","title":"Croma.ListMonad","type":"module"},{"doc":"Default implementation of Applicative's ap operation. Modules that implement Croma.Monad may override this default implementation. Note that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator |&gt; .","ref":"Croma.ListMonad.html#ap/2","title":"Croma.ListMonad.ap/2","type":"function"},{"doc":"Implementation of bind operation of Monad. Alias to Enum.flat_map/2 .","ref":"Croma.ListMonad.html#bind/2","title":"Croma.ListMonad.bind/2","type":"function"},{"doc":"A macro that provides Hakell-like do-notation. Examples MonadImpl . m do x &lt;- mx y &lt;- my pure f ( x , y ) end is expanded to MonadImpl . bind ( mx , fn x -&gt; MonadImpl . bind ( my , fn y -&gt; MonadImpl . pure f ( x , y ) end ) end )","ref":"Croma.ListMonad.html#m/1","title":"Croma.ListMonad.m/1","type":"macro"},{"doc":"Default implementation of Functor's fmap operation. Modules that implement Croma.Monad may override this default implementation. Note that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator |&gt; .","ref":"Croma.ListMonad.html#map/2","title":"Croma.ListMonad.map/2","type":"function"},{"doc":"Implementation of pure operation of Monad (or Applicative). Wraps the given value into a list.","ref":"Croma.ListMonad.html#pure/1","title":"Croma.ListMonad.pure/1","type":"function"},{"doc":"Converts the given list of monadic (to be precise, applicative) objects into a monadic object that contains a single list. Modules that implement Croma.Monad may override this default implementation. Examples (using Croma.Result) iex&gt; Croma.Result . sequence ( [ { :ok , 1 } , { :ok , 2 } , { :ok , 3 } ] ) { :ok , [ 1 , 2 , 3 ] } iex&gt; Croma.Result . sequence ( [ { :ok , 1 } , { :error , :foo } , { :ok , 3 } ] ) { :error , :foo }","ref":"Croma.ListMonad.html#sequence/1","title":"Croma.ListMonad.sequence/1","type":"function"},{"doc":"","ref":"Croma.ListMonad.html#t:t/1","title":"Croma.ListMonad.t/1","type":"type"},{"doc":"Module that represents the Elixir's built-in map type. Intended to be used with other parts of croma to express map variables.","ref":"Croma.Map.html","title":"Croma.Map","type":"module"},{"doc":"Simply checks the argument's type using is_map(var!(x)) .","ref":"Croma.Map.html#valid?/1","title":"Croma.Map.valid?/1","type":"function"},{"doc":"","ref":"Croma.Map.html#t:t/0","title":"Croma.Map.t/0","type":"type"},{"doc":"This module defines an interface for monad . Modules that use this module must provide concrete implementations of the following: @type t(a) @spec pure(a) :: t(a) when a: any @spec bind(t(a), (a -&gt; t(b))) :: t(b) when a: any, b: any Note that the order of parameters in map / ap is different from that of Haskell counterparts, in order to leverage Elixir's pipe operator |&gt; . Using concrete implementations of the above interfaces, this module generates default implementations of some functions/macros. See Croma.Result for the generated functions/macros. Croma.Monad also provides bind -less syntax similar to Haskell's do-notation with m/1 macro.","ref":"Croma.Monad.html","title":"Croma.Monad","type":"module"},{"doc":"Module that represents the Elixir's built-in neg_integer type. Intended to be used with other parts of croma to express neg_integer variables.","ref":"Croma.NegInteger.html","title":"Croma.NegInteger","type":"module"},{"doc":"Simply checks the argument's type using is_integer(var!(x)) and var!(x) &lt; 0 .","ref":"Croma.NegInteger.html#valid?/1","title":"Croma.NegInteger.valid?/1","type":"function"},{"doc":"","ref":"Croma.NegInteger.html#t:t/0","title":"Croma.NegInteger.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in non_neg_integer type. Intended to be used with other parts of croma to express non_neg_integer variables.","ref":"Croma.NonNegInteger.html","title":"Croma.NonNegInteger","type":"module"},{"doc":"Simply checks the argument's type using is_integer(var!(x)) and var!(x) &gt;= 0 .","ref":"Croma.NonNegInteger.html#valid?/1","title":"Croma.NonNegInteger.valid?/1","type":"function"},{"doc":"","ref":"Croma.NonNegInteger.html#t:t/0","title":"Croma.NonNegInteger.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in number type. Intended to be used with other parts of croma to express number variables.","ref":"Croma.Number.html","title":"Croma.Number","type":"module"},{"doc":"Simply checks the argument's type using is_number(var!(x)) .","ref":"Croma.Number.html#valid?/1","title":"Croma.Number.valid?/1","type":"function"},{"doc":"","ref":"Croma.Number.html#t:t/0","title":"Croma.Number.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in pid type. Intended to be used with other parts of croma to express pid variables.","ref":"Croma.Pid.html","title":"Croma.Pid","type":"module"},{"doc":"Simply checks the argument's type using is_pid(var!(x)) .","ref":"Croma.Pid.html#valid?/1","title":"Croma.Pid.valid?/1","type":"function"},{"doc":"","ref":"Croma.Pid.html#t:t/0","title":"Croma.Pid.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in port type. Intended to be used with other parts of croma to express port variables.","ref":"Croma.Port.html","title":"Croma.Port","type":"module"},{"doc":"Simply checks the argument's type using is_port(var!(x)) .","ref":"Croma.Port.html#valid?/1","title":"Croma.Port.valid?/1","type":"function"},{"doc":"","ref":"Croma.Port.html#t:t/0","title":"Croma.Port.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in pos_integer type. Intended to be used with other parts of croma to express pos_integer variables.","ref":"Croma.PosInteger.html","title":"Croma.PosInteger","type":"module"},{"doc":"Simply checks the argument's type using is_integer(var!(x)) and var!(x) &gt; 0 .","ref":"Croma.PosInteger.html#valid?/1","title":"Croma.PosInteger.valid?/1","type":"function"},{"doc":"","ref":"Croma.PosInteger.html#t:t/0","title":"Croma.PosInteger.t/0","type":"type"},{"doc":"Module that represents the Elixir's built-in reference type. Intended to be used with other parts of croma to express reference variables.","ref":"Croma.Reference.html","title":"Croma.Reference","type":"module"},{"doc":"Simply checks the argument's type using is_reference(var!(x)) .","ref":"Croma.Reference.html#valid?/1","title":"Croma.Reference.valid?/1","type":"function"},{"doc":"","ref":"Croma.Reference.html#t:t/0","title":"Croma.Reference.t/0","type":"type"},{"doc":"A simple data structure to represent a result of computation that can either succeed or fail, in the form of {:ok, any} or {:error, any} . In addition to many utility functions, this module also provides implementation of Croma.Monad interface for Croma.Result.t/1 . This enables the following Haskell-ish syntax: iex&gt; use Croma ...&gt; Croma.Result . m do ...&gt; x &lt;- { :ok , 1 } ...&gt; y &lt;- { :ok , 2 } ...&gt; pure x + y ...&gt; end { :ok , 3 } The above code is expanded to the code that uses pure/1 and bind/2 . Croma.Result . bind ( { :ok , 1 } , fn x -&gt; Croma.Result . bind ( { :ok , 2 } , fn y -&gt; Croma.Result . pure ( x + y ) end ) end ) This is useful when handling multiple computations that may go wrong in a short-circuit manner: iex&gt; use Croma ...&gt; Croma.Result . m do ...&gt; x &lt;- { :error , :foo } ...&gt; y &lt;- { :ok , 2 } ...&gt; pure x + y ...&gt; end { :error , :foo }","ref":"Croma.Result.html","title":"Croma.Result","type":"module"},{"doc":"Default implementation of Applicative's ap operation. Modules that implement Croma.Monad may override this default implementation. Note that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator |&gt; .","ref":"Croma.Result.html#ap/2","title":"Croma.Result.ap/2","type":"function"},{"doc":"Implementation of bind operation of Monad. Executes the given function if the result is in :ok state; otherwise returns the failed result.","ref":"Croma.Result.html#bind/2","title":"Croma.Result.bind/2","type":"function"},{"doc":"Based on existing functions that return Croma.Result.t(any) , defines functions that raise on error. Each generated function simply calls the specified function and then passes the returned value to Croma.Result.get!/1 . Examples iex&gt; defmodule M do ...&gt; def f ( a ) do ...&gt; { :ok , a + 1 } ...&gt; end ...&gt; Croma.Result . define_bang_version_of ( f : 1 ) ...&gt; end iex&gt; M . f ( 1 ) { :ok , 2 } iex&gt; M . f! ( 1 ) 2 If appropriate spec of original function is available, spec of the bang version is also declared. For functions that have default arguments it's necessary to explicitly pass all arities to Croma.Result.define_bang_version_of/1 .","ref":"Croma.Result.html#define_bang_version_of/1","title":"Croma.Result.define_bang_version_of/1","type":"macro"},{"doc":"Returns true if the given result is in the form of {:error, _} .","ref":"Croma.Result.html#error?/1","title":"Croma.Result.error?/1","type":"function"},{"doc":"Returns the value associated with :ok in the given result. Returns nil if the result is in the form of {:error, _} . Examples iex&gt; Croma.Result . get ( { :ok , 1 } ) 1 iex&gt; Croma.Result . get ( { :error , :foo } ) nil","ref":"Croma.Result.html#get/1","title":"Croma.Result.get/1","type":"function"},{"doc":"Returns the value associated with :ok in the given result. Returns default if the result is in the form of {:error, _} . Examples iex&gt; Croma.Result . get ( { :ok , 1 } , 0 ) 1 iex&gt; Croma.Result . get ( { :error , :foo } , 0 ) 0","ref":"Croma.Result.html#get/2","title":"Croma.Result.get/2","type":"function"},{"doc":"Returns the value associated with :ok in the given result. Raises ArgumentError if the result is in the form of {:error, _} . Examples iex&gt; Croma.Result . get! ( { :ok , 1 } ) 1 iex&gt; Croma.Result . get! ( { :error , :foo } ) ** (ArgumentError) element not present: {:error, :foo}","ref":"Croma.Result.html#get!/1","title":"Croma.Result.get!/1","type":"function"},{"doc":"A macro that provides Hakell-like do-notation. Examples MonadImpl . m do x &lt;- mx y &lt;- my pure f ( x , y ) end is expanded to MonadImpl . bind ( mx , fn x -&gt; MonadImpl . bind ( my , fn y -&gt; MonadImpl . pure f ( x , y ) end ) end )","ref":"Croma.Result.html#m/1","title":"Croma.Result.m/1","type":"macro"},{"doc":"Default implementation of Functor's fmap operation. Modules that implement Croma.Monad may override this default implementation. Note that the order of arguments is different from the Haskell counterpart, in order to leverage Elixir's pipe operator |&gt; .","ref":"Croma.Result.html#map/2","title":"Croma.Result.map/2","type":"function"},{"doc":"Transforms a result by applying a function to its contained :error value. If the given result is in :ok state it is returned without using the given function.","ref":"Croma.Result.html#map_error/2","title":"Croma.Result.map_error/2","type":"function"},{"doc":"Returns true if the given result is in the form of {:ok, _value} .","ref":"Croma.Result.html#ok?/1","title":"Croma.Result.ok?/1","type":"function"},{"doc":"Tries to take one result in :ok state from the given two. If the first result is in :ok state it is returned. Otherwise the second result is returned. Note that or_else/2 is a macro instead of a function in order to short-circuit evaluation of the second argument, i.e. the second argument is evaluated only when the first argument is in :error state.","ref":"Croma.Result.html#or_else/2","title":"Croma.Result.or_else/2","type":"macro"},{"doc":"Implementation of pure operation of Monad (or Applicative). Wraps the given value into a Croma.Result , i.e., returns {:ok, arg} .","ref":"Croma.Result.html#pure/1","title":"Croma.Result.pure/1","type":"function"},{"doc":"Converts the given list of monadic (to be precise, applicative) objects into a monadic object that contains a single list. Modules that implement Croma.Monad may override this default implementation. Examples (using Croma.Result) iex&gt; Croma.Result . sequence ( [ { :ok , 1 } , { :ok , 2 } , { :ok , 3 } ] ) { :ok , [ 1 , 2 , 3 ] } iex&gt; Croma.Result . sequence ( [ { :ok , 1 } , { :error , :foo } , { :ok , 3 } ] ) { :error , :foo }","ref":"Croma.Result.html#sequence/1","title":"Croma.Result.sequence/1","type":"function"},{"doc":"Executes the given function within a try-rescue block and wraps the return value as {:ok, retval} . If the function raises an exception, try/1 returns the exception in the form of {:error, exception} . Examples iex&gt; Croma.Result . try ( fn -&gt; 1 + 1 end ) { :ok , 2 } iex&gt; Croma.Result . try ( fn -&gt; raise &quot;foo&quot; end ) { :error , % RuntimeError { message : &quot;foo&quot; } }","ref":"Croma.Result.html#try/1","title":"Croma.Result.try/1","type":"function"},{"doc":"Simply checks if the given term is ok- or error-tuple. Using this function you can write e.g. r :: v[Croma.Result.t(integer)] in your parameter list of defun macro to validate r is of type t/0 . However note that this function only checks the outmost structure of an argument; 2nd value in the 2-tuple won't be validated for the given type parameter (in the above example it won't verify whether r contains an integer or not).","ref":"Croma.Result.html#valid?/1","title":"Croma.Result.valid?/1","type":"function"},{"doc":"Wraps a given value in an :ok tuple if mod.valid?/1 returns true for the value. Otherwise returns an :error tuple.","ref":"Croma.Result.html#wrap_if_valid/2","title":"Croma.Result.wrap_if_valid/2","type":"function"},{"doc":"","ref":"Croma.Result.html#t:t/0","title":"Croma.Result.t/0","type":"type"},{"doc":"","ref":"Croma.Result.html#t:t/1","title":"Croma.Result.t/1","type":"type"},{"doc":"","ref":"Croma.Result.html#t:t/2","title":"Croma.Result.t/2","type":"type"},{"doc":"Module that represents the Elixir's built-in String.t type. Intended to be used with other parts of croma to express String.t variables.","ref":"Croma.String.html","title":"Croma.String","type":"module"},{"doc":"Simply checks the argument's type using is_binary(var!(x)) .","ref":"Croma.String.html#valid?/1","title":"Croma.String.valid?/1","type":"function"},{"doc":"","ref":"Croma.String.html#t:t/0","title":"Croma.String.t/0","type":"type"},{"doc":"Module to define structs with validation and conversion functions, based on its type information. Using this module requires to prepare type modules for all struct fields. Each of per-field type module is expected to provide the following members: required: @type t required: @spec valid?(term) :: boolean optional: @spec default() :: t optional: @spec new(term) :: Croma.Result.t(t) Some helpers for defining such per-field type modules are available. Wrappers of built-in types such as Croma.String , Croma.Integer , etc. Utility modules such as Croma.SubtypeOfString to define &quot;subtypes&quot; of existing types. Ad-hoc module generators defined in Croma.TypeGen . This module, Croma.Struct itself for nested structs. To define a struct, use this module with a keyword list where keys are field names and values are type modules: defmodule S do use Croma.Struct , fields : [ field1_name : Field1Module , field2_name : Field2Module , ] end Then the above code generates defstruct , @type t and the following functions: @spec valid?(term) :: boolean @spec new(term) :: Croma.Result.t(t) @spec new!(term) :: t @spec update(t, Dict.t) :: Croma.Result.t(t) @spec update!(t, Dict.t) :: t The functions listed above are all overridable, so you can for example implement your own validation rule that spans multiple fields. Examples iex&gt; defmodule I do ...&gt; @type t :: integer ...&gt; def valid? ( i ) , do : is_integer ( i ) ...&gt; def default ( ) , do : 0 ...&gt; end ...&gt; defmodule S do ...&gt; use Croma.Struct , fields : [ i : I ] ...&gt; end ...&gt; S . new ( %{ i : 5 } ) { :ok , % S { i : 5 } } ...&gt; S . valid? ( % S { i : &quot;not_an_integer&quot; } ) false ...&gt; { :ok , s } = S . new ( %{ } ) { :ok , % S { i : 0 } } ...&gt; S . update ( s , [ i : 2 ] ) { :ok , % S { i : 2 } } ...&gt; S . update ( s , %{ &quot;i&quot; =&gt; &quot;not_an_integer&quot; } ) { :error , { :invalid_value , [ S , { I , :i } ] } } Default value of each field You can specify default value of each struct field by giving :default option in per-field options defining default/0 in the field's type module (which is evaluated at compile-time) If you specify both, (1) takes precedence over (2). Additionally, you can tell Croma.Struct not to use default/0 by specifying no_default?: true . If no default value is provided for a field, then the field must be explicitly filled when constructing a new struct. As an example, suppose you have the following modules. defmodule I do use Croma.SubtypeOfInt , min : 0 , default : 1 end defmodule S do use Croma.Struct , fields : [ a : Croma.Integer , b : I , c : { Croma.Integer , [ default : 2 ] } , d : { I , [ default : 3 ] } , e : { Croma.Integer , [ no_default? : true ] } , f : { I , [ no_default? : true ] } , ] end Note that I has default/0 whereas Croma.Integer does not export default/0 . Then, a , e and f have no default values Default value of b is 1 Default value of c is 2 Default value of d is 3 new/1 new/1 generated by Croma.Struct deserves special attention. new/1 can be useful when validating and converting data structure obtained from e.g. JSON into an Elixir structs. As with other type modules' new/1 , new/1 generated by Croma.Struct can accept value where valid?/1 evaluates to false ; it tries to convert that value into a valid form. Most notable example of this behaviour is that new/1 accepts not only atom-keyed maps but also string-keyed maps, although structs are atom-keyed maps. How it works new/1 tries to get valid values for all struct fields from the given map or keyword list. For each field of the struct, a value is computed as follows: If a value is not found for a field, If the field has default value, that default is taken. If a value is found for a field, If the module for the field exports new/1 it is called with the found value. If the module for the field does not export new/1 , the found value is instead validated with valid?/1 . When no valid value can be obtained for any of the struct fields, new/1 returns an error. Note that the usage of field modules' new/1 enables to construct arbitrarily nested data structure in a recursive manner. Naming convention of field names (case of identifiers) When working with structured data (e.g. JSON) from systems with different naming conventions, it's convenient to adjust the names to your favorite convention in this layer. You can specify the acceptable naming schemes of data structures to be converted by new/1 and new!/1 using :accept_case option of use Croma.Struct . nil (default): Accepts only the given field names. :lower_camel : Accepts both the given field names and their lower camel variants. :upper_camel : Accepts both the given field names and their upper camel variants. :snake : Accepts both the given field names and their snake cased variants. :capital : Accepts both the given field names and their variants where all characters are capital. Tips To distinguish missing field and explict nil in new/1 Simply using Croma.TypeGen.nilable/1 for struct fields, we cannot distinguish whether the value is not given or nil is explicitly given, as the resulting struct contains nil for both cases. By adjusting default value for the field we can distinguish these case. As an example suppose we have the following S . defmodule S do use Croma.Struct , fields : [ field : { union ( [ fixed ( :unset ) , fixed ( nil ) , Croma.Integer ] ) , [ default : :unset ] } , ] end Then we can distinguish these patterns. S.new(%{}) == %S{field: :unset} S.new(%{field: nil}) == %S{field: nil} S.new(%{field: 1}) == %S{field: 1} In this example we use Croma.TypeGen.union/1 and Croma.TypeGen.fixed/1 , but one can of course define his/her own type module that accepts these 3 cases. In a similar manner, by setting default value for field we can implement struct fields that accepts missing field but rejects explicit nil , or accepts explicit nil but rejects missing field.","ref":"Croma.Struct.html","title":"Croma.Struct","type":"module"},{"doc":"Helper module to define type whose members are a fixed set of atoms. The following members are generated by use Croma.SubtypeOfAtom : @type t @spec valid?(term) :: boolean @spec new(term) :: Croma.Result.t(t) (tries to convert String.t to the given set of atoms) @spec new!(term) :: t Options: :values - List of atoms of possible values. :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyAtom do use Croma.SubtypeOfAtom , values : [ :foo , :bar , :baz ] , default : :foo end","ref":"Croma.SubtypeOfAtom.html","title":"Croma.SubtypeOfAtom","type":"module"},{"doc":"Helper module to define float-based types. The following members are generated by use Croma.SubtypeOfFloat : @type t @spec valid?(term) :: boolean Options: :min - Minimum value of this type (inclusive). :max - Maximum value of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyFloat do use Croma.SubtypeOfFloat , min : 0.0 , max : 5.0 , default : 0.0 end","ref":"Croma.SubtypeOfFloat.html","title":"Croma.SubtypeOfFloat","type":"module"},{"doc":"Helper module to define float-based types. The following members are generated by use Croma.SubtypeOfFloatWithConversionFromInt : @type t @spec valid?(term) :: boolean @spec new(term) :: Croma.Result.t(t) This variant of Croma.SubtypeOfFloat is useful for e.g. float field in a struct that models JSON data so that both 1.0 and 1 in JSON representation can be automatically converted to elixir's float value by new/1 . Options: :min - Minimum value of this type (inclusive). :max - Maximum value of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyFloat do use Croma.SubtypeOfFloatWithConversionFromInt , min : 0.0 , max : 5.0 , default : 0.0 end","ref":"Croma.SubtypeOfFloatWithConversionFromInt.html","title":"Croma.SubtypeOfFloatWithConversionFromInt","type":"module"},{"doc":"Helper module to define integer-based types. The following members are generated by use Croma.SubtypeOfInt : @type t @spec valid?(term) :: boolean Options: :min - Minimum value of this type (inclusive). :max - Maximum value of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyInt do use Croma.SubtypeOfInt , min : 0 , max : 10 , default : 0 end","ref":"Croma.SubtypeOfInt.html","title":"Croma.SubtypeOfInt","type":"module"},{"doc":"Helper module to define list-based types. The following members are generated by use Croma.SubtypeOfList : @type t @spec valid?(term) :: boolean If elem_module exports new/1 , @spec new(term) :: Croma.Result.t(t) @spec new!(term) :: t Options: :elem_module - A type module for elements. :min_length - Minimum length of valid values of this type (inclusive). :max_length - Maximum length of valid values of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyList do use Croma.SubtypeOfList , elem_module : MyInt , default : [ ] end","ref":"Croma.SubtypeOfList.html","title":"Croma.SubtypeOfList","type":"module"},{"doc":"Helper module to define map-based types. The following members are generated by use Croma.SubtypeOfMap : @type t @spec valid?(term) :: boolean If key_module and/or value_module exports new/1 , @spec new(term) :: Croma.Result.t(t) @spec new!(term) :: t Options: :key_module - A type module for keys. :value_module - A type module for values. :min_size - Minimum size of valid values of this type (inclusive). :max_size - Maximum size of valid values of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyMap do use Croma.SubtypeOfMap , key_module : MyString , value_module : MyInt , default : %{ } end","ref":"Croma.SubtypeOfMap.html","title":"Croma.SubtypeOfMap","type":"module"},{"doc":"Helper module to define number-based (integer or float) types. The following members are generated by use Croma.SubtypeOfNumber : @type t @spec valid?(term) :: boolean Options: :min - Minimum value of this type (inclusive). :max - Maximum value of this type (inclusive). :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyNumber do use Croma.SubtypeOfNumber , min : 0 , max : 3.141592653589793 , default : 0 end","ref":"Croma.SubtypeOfNumber.html","title":"Croma.SubtypeOfNumber","type":"module"},{"doc":"Helper module to define string-based types. The following members are generated by use Croma.SubtypeOfString : @type t @spec valid?(term) :: boolean Options: :pattern - A regex pattern to check whether a string is classified into this type or not. :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyString do use Croma.SubtypeOfString , pattern : ~r/^foo|bar$/ , default : &quot;foo&quot; end","ref":"Croma.SubtypeOfString.html","title":"Croma.SubtypeOfString","type":"module"},{"doc":"Helper module to define tuple-based types. The following members are generated by use Croma.SubtypeOfTuple : @type t @spec valid?(term) :: boolean If any of :elem_modules exports new/1 , @spec new(term) :: Croma.Result.t(t) @spec new!(term) :: t Options: :elem_modules - A list of type modules for tuple elements. :default - Default value for this type. Passing this option generates default/0 . Examples defmodule MyTuple do use Croma.SubtypeOfTuple , elem_modules : [ MyInt , MyString ] end","ref":"Croma.SubtypeOfTuple.html","title":"Croma.SubtypeOfTuple","type":"module"},{"doc":"Module to be use d by test modules to make tests a bit shorter. use Croma.TestCase is almost the same as use ExUnit.Case . Options passed to use Croma.TestCase will also be passed to use ExUnit.Case . The only difference is that it automatically adds an alias to the test target module, which is inferred from the name of the test module. Example defmodule MyProject.SomeModuleTest do use Croma.TestCase ... end is equivalent to defmodule MyProject.SomeModuleTest do use ExUnit.Case alias MyProject.SomeModule ... end If you want to pass as option to alias , use alias_as : defmodule MyProject.SomeModuleTest do use Croma.TestCase , alias_as : M ... end is converted to defmodule MyProject.SomeModuleTest do use ExUnit.Case alias MyProject.SomeModule , as : M ... end","ref":"Croma.TestCase.html","title":"Croma.TestCase","type":"module"},{"doc":"Module that represents the Elixir's built-in tuple type. Intended to be used with other parts of croma to express tuple variables.","ref":"Croma.Tuple.html","title":"Croma.Tuple","type":"module"},{"doc":"Simply checks the argument's type using is_tuple(var!(x)) .","ref":"Croma.Tuple.html#valid?/1","title":"Croma.Tuple.valid?/1","type":"function"},{"doc":"","ref":"Croma.Tuple.html#t:t/0","title":"Croma.Tuple.t/0","type":"type"},{"doc":"Module that defines macros for ad-hoc (in other words &quot;in-line&quot;) module definitions.","ref":"Croma.TypeGen.html","title":"Croma.TypeGen","type":"module"},{"doc":"Creates a new module that simply represents a type whose sole member is the given value. Only atoms and integers are supported.","ref":"Croma.TypeGen.html#fixed/1","title":"Croma.TypeGen.fixed/1","type":"macro"},{"doc":"An ad-hoc version of Croma.SubtypeOfList . Options: :define_default0? - Boolean value that indicates whether to define default/0 (which simply returns [] ). Defaults to true .","ref":"Croma.TypeGen.html#list_of/2","title":"Croma.TypeGen.list_of/2","type":"macro"},{"doc":"Creates a new module that represents a nilable type, based on the given type module module . Using the given type module nilable/1 generates a new module that defines: @type t :: nil | module.t @spec valid?(term) :: boolean @spec default() :: nil If the given module exports new/1 @spec new(term) :: Croma.Result.t(t) @spec new!(term) :: t This is useful in defining a struct with nilable fields using Croma.Struct . Examples iex&gt; use Croma ...&gt; defmodule I do ...&gt; use Croma.SubtypeOfInt , min : 0 ...&gt; end ...&gt; defmodule S do ...&gt; use Croma.Struct , fields : [ not_nilable_int : I , nilable_int : Croma.TypeGen . nilable ( I ) ] ...&gt; end ...&gt; S . new ( %{ not_nilable_int : 0 , nilable_int : nil } ) % S { nilable_int : nil , not_nilable_int : 0 }","ref":"Croma.TypeGen.html#nilable/1","title":"Croma.TypeGen.nilable/1","type":"macro"},{"doc":"Creates a new module that represents a sum type of the given types. The argument must be a list of type modules. Note that the specified types should be mutually disjoint; otherwise new/1 can return unexpected results depending on the order of the type modules.","ref":"Croma.TypeGen.html#union/1","title":"Croma.TypeGen.union/1","type":"macro"},{"doc":"Utilities to work with internal representation of types.","ref":"Croma.TypeUtil.html","title":"Croma.TypeUtil","type":"module"},{"doc":"","ref":"Croma.TypeUtil.html#fetch_spec_info_at_compile_time/1","title":"Croma.TypeUtil.fetch_spec_info_at_compile_time/1","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#fetch_type_info_at_compile_time/2","title":"Croma.TypeUtil.fetch_type_info_at_compile_time/2","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#list_to_type_union/1","title":"Croma.TypeUtil.list_to_type_union/1","type":"function"},{"doc":"","ref":"Croma.TypeUtil.html#resolve_primitive/3","title":"Croma.TypeUtil.resolve_primitive/3","type":"function"},{"doc":"Module for code generation of argument validation (see Croma.Defun.defun/2 ). This module is intended for internal use.","ref":"Croma.Validation.html","title":"Croma.Validation","type":"module"},{"doc":"","ref":"Croma.Validation.html#make/3","title":"Croma.Validation.make/3","type":"function"},{"doc":"","ref":"Croma.DebugAssertError.html","title":"Croma.DebugAssertError","type":"exception"}]